/*!
    \file    gd32e23x_it.c
    \brief   interrupt service routines

    \version 2024-02-22, V2.1.0, firmware for GD32E23x
*/

/*
    Copyright (c) 2024, GigaDevice Semiconductor Inc.

    Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

    1. Redistributions of source code must retain the above copyright notice, this
       list of conditions and the following disclaimer.
    2. Redistributions in binary form must reproduce the above copyright notice,
       this list of conditions and the following disclaimer in the documentation
       and/or other materials provided with the distribution.
    3. Neither the name of the copyright holder nor the names of its contributors
       may be used to endorse or promote products derived from this software without
       specific prior written permission.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY
OF SUCH DAMAGE.
*/

#include "gd32e23x_it.h"
#include "main.h"
#include "systick.h"
#include "ldc1612.h"
#include "rs485.h"
#include "led.h"

/*!
    \brief      this function handles NMI exception
    \param[in]  none
    \param[out] none
    \retval     none
*/
void NMI_Handler(void) {
    /* if NMI exception occurs, go to infinite loop */
    while (1) {
    }
}

/*!
    \brief      this function handles HardFault exception
    \param[in]  none
    \param[out] none
    \retval     none
*/
void HardFault_Handler(void) {
    /* if Hard Fault exception occurs, go to infinite loop */
    while (1) {
    }
}

/*!
    \brief      this function handles SVC exception
    \param[in]  none
    \param[out] none
    \retval     none
*/
void SVC_Handler(void) {
    /* if SVC exception occurs, go to infinite loop */
    while (1) {
    }
}

/*!
    \brief      this function handles PendSV exception
    \param[in]  none
    \param[out] none
    \retval     none
*/
void PendSV_Handler(void) {
    /* if PendSV exception occurs, go to infinite loop */
    while (1) {
    }
}

/*!
    \brief      this function handles SysTick exception
    \param[in]  none
    \param[out] none
    \retval     none
*/
void SysTick_Handler(void) {
}

/**
  * @brief  This function handles TIMER5 interrupt request.
  * @param[in]  none
  * @param[out] none
  * @retval None
  */
void TIMER16_IRQHandler(void) {
    if (timer_interrupt_flag_get(LED_TIMER, TIMER_INT_FLAG_UP) == SET) {
        timer_interrupt_flag_clear(LED_TIMER, TIMER_INT_FLAG_UP);
        static uint8_t led_status = 0;
        if (led_status) {
            gpio_bit_write(LED_PORT, LED_PIN, RESET);
            timer_autoreload_value_config(LED_TIMER, 19200);
        } else {
            gpio_bit_write(LED_PORT, LED_PIN, SET);
            timer_autoreload_value_config(LED_TIMER, 800);
        }
        led_status = !led_status;
    }
}

void USART0_IRQHandler(void) {
    static uint8_t rx_index = 0;
    static uint8_t rx_buffer[RX_BUFFER_SIZE];

    if (RESET != usart_interrupt_flag_get(USART0, USART_INT_FLAG_RBNE)) {
        usart_interrupt_flag_clear(USART0, USART_INT_FLAG_RBNE);
        uint8_t received_data = (uint8_t) usart_data_receive(USART0);

        // 将接收到的数据存储到缓冲区
        if (rx_index < RX_BUFFER_SIZE - 1) {
            rx_buffer[rx_index++] = received_data;
        }

        // printf("len: %d, data: %c\r\n", rx_index, received_data);

        // 检查是否接收到换行符，表示指令结束
        // if (received_data == '\n') {
            if (calculate_crc(rx_buffer, rx_index - 1) == rx_buffer[rx_index - 1]) {
                // printf("CRC check success");
                // rx_buffer[rx_index] = '\0'; // 添加字符串结束符
                process_command(rx_buffer, rx_index); // 处理指令
                rx_index = 0; // 重置缓冲区索引
                // printf("%c", 0xff);
            } else {
                // printf("CRC check failed");
                // printf("%c%c%c%c", 0xB5, 0xF2, 0x00, 0xF2);
                // fflush(stdout);
                rx_index = 0; // 重置缓冲区索引
                return;
            }

        // }
    }
}
